using System;
using System.Collections.Generic;
using System.Text;
using Node = ChatBot.ConversationTree.ConversationNode;

namespace ChatBot
{
    abstract class BasicBot : UserBot
    {
        public override ConversationTree GenerateTree()
        {
            /////////////////////////////////////////////////////////////////////
            // Define the root node.  This is the first node in the conversation.
            Node root = new Node();
            root.setFunction(delegate(object sender, UserMessage message)
            {
                root.botResponse = HandleMessage(message.Message, message.From);
            });

            /////////////////////////////////////////////////////////////////////
            // Create the Conversation Tree.  All nodes here are in some way attached to it
            ConversationTree ct = new ConversationTree(root);

            return ct;
        }

        // A default message handler that just echoes back the message that was received and the
        // name of the user that sent it.
        public override string HandleMessage(string message, string user)
        {
            return message + " sent by " + user;
        }
    }
}
