using System;
using System.Collections;
using System.Text.RegularExpressions;
using System.Xml;
using System.IO;
using System.Net;
using System.Text;

class User
{
    static Random r = new Random();

    public static string Input()
    {
        ArrayList list = new ArrayList();
        list.Add("yes");
        list.Add("no");
        list.Add("maybe");

        string s = (string)list[r.Next(list.Count)];
        return s;
    }

    public static int RandNum() 
    {
    	return r.Next(1, 11);  //Return a random int between 1 and 10    
    }

    public static string RandomChoice(params string[] list) {
    	return (string)list[r.Next(list.Length)];
    }

    //takes a string with HTML code in it and takes out the code.
    public static string StripHTML(string s)
    {
    	Regex regex = new Regex("<[^>]*>", RegexOptions.IgnoreCase);
    	return regex.Replace(s, "");
    }
    
    //---------------------------------------RSS general functions ----------------------------------//
    
    public static string RSSget(string url, string noFindMessage, string entryNumber, string property){
        try{
        	int num = Convert.ToInt32(entryNumber);
        	XmlDocument x = new XmlDocument();
       		x.Load(url);
        	XmlNodeList itemXNL = x.SelectNodes("/rss/channel/item");
        	if(itemXNL.Item(num) == null){
        		return noFindMessage;
        	}else{
        		string prop = itemXNL.Item(num).SelectSingleNode(property).InnerText;
        		
        		prop = prop.Trim().Replace('\n',' ').Replace('\t',' ').Replace('\r',' ');
       			return prop;	
        	}
        }catch (XmlException){
        	return "<RSS ERROR>";
    	}
    }
    
    public static string RSSgetTitle(string url, string noFindMessage, string entryNumber){
    	return RSSget(url, noFindMessage, entryNumber, "title");
    }
    
    public static string RSSgetTitle(string url, string noFindMessage){
    	return RSSgetTitle(url,noFindMessage, "0");
    }
    
    public static string RSSgetTitle(string url){
    	return RSSgetTitle(url,"<Error: can't find RSS entry>");
    }
        
    public static string RSSgetLink(string url, string noFindMessage, string entryNumber){
    	return RSSget(url, noFindMessage, entryNumber, "link");
    }
    
    public static string RSSgetLink(string url, string noFindMessage){
    	return RSSgetLink(url,noFindMessage, "0");
    }
    
    public static string RSSgetLink(string url){
    	return RSSgetLink(url,"<Error: can't find RSS entry>");
    }
    
    public static string RSSgetDescription(string url, string noFindMessage, string entryNumber){
    	return StripHTML(RSSget(url, noFindMessage, entryNumber, "description"));
    }
    
    public static string RSSgetDescription(string url, string noFindMessage){
    	return RSSgetDescription(url,noFindMessage, "0");
    }
    
    public static string RSSgetDescription(string url){
    	return RSSgetDescription(url,"<Error: can't find RSS entry>");
    }
    
    //---------------------------------------RSS google news functions ----------------------------------//
    //------advanced
    public static string RSSGoogleNewsTitle(string searchTerm, string noFindMessage, string entryNumber){
    	searchTerm = Regex.Replace(searchTerm, @"\s", "+");
    	String url = "http://news.google.com/news?q= " + searchTerm + "&output=rss";
    	return RSSgetTitle(url, noFindMessage, entryNumber);
    }
    
    
    public static string RSSGoogleNewsLink(string searchTerm, string noFindMessage, string entryNumber){
    	searchTerm = Regex.Replace(searchTerm, @"\s", "+");
    	String url = "http://news.google.com/news?q= " + searchTerm + "&output=rss";
    	return RSSgetLink(url, noFindMessage, entryNumber);
    }
    
    public static string RSSGoogleNewsDescription(string searchTerm, string noFindMessage, string entryNumber){
        	searchTerm = Regex.Replace(searchTerm, @"\s", "+");
        	String url = "http://news.google.com/news?q= " + searchTerm + "&output=rss";
        	return RSSgetDescription(url, noFindMessage, entryNumber);
    }
    
    public static string RSSTwitterFeeds(string rssID)
    {
    	String url = "http://twitter.com/statuses/friends_timeline/" + "rssID" + ".rss";
    	return RSSgetDescription(url, "cannot find", "1");
    }

    //------intuitive
    public static string RSSGoogleNewsTitle(string searchTerm){
        return RSSGoogleNewsTitle(searchTerm, "Oooops. I couldn't find news for that!", "0");
    }
     
    public static string RSSGoogleNewsLink(string searchTerm){
        return RSSGoogleNewsLink(searchTerm, "Oooops. I couldn't find news for that!", "0");
    }
        
    public static string RSSGoogleNewsDescription(string searchTerm){
        return RSSGoogleNewsDescription(searchTerm, "Oooops. I couldn't find news for that!", "0");
    }
    
    //---------------------------------------RSS weather functions ----------------------------------//
    //------advanced
    public static string RSSWeatherTitle(string city, string state, string noFindMessage, string entryNumber){
        city = Regex.Replace(city, @"\s", "_");
        state = Regex.Replace(state, @"\s", "_");
        String url = "http://rss.wunderground.com/auto/rss_full/" + state + "/" + city + ".xml?units=both";
        return RSSgetTitle(url, noFindMessage, entryNumber);
    }
    
    public static string RSSWeatherLink(string city, string state, string noFindMessage, string entryNumber){
        city = Regex.Replace(city, @"\s", "_");
        state = Regex.Replace(state, @"\s", "_");
        String url = "http://rss.wunderground.com/auto/rss_full/" + state + "/" + city + ".xml?units=both";
        return RSSgetLink(url, noFindMessage, entryNumber);
    }    

    public static string RSSWeatherDescription(string city, string state, string noFindMessage, string entryNumber){
        city = Regex.Replace(city, @"\s", "_");
        state = Regex.Replace(state, @"\s", "_");
        String url = "http://rss.wunderground.com/auto/rss_full/" + state + "/" + city + ".xml?units=both";
        return RSSgetDescription(url, noFindMessage, entryNumber);
    }        

    //------intuitive        
    public static string RSSWeatherToday(string city, string state){
        return RSSWeatherDescription(city, state, "I can't find that location.", "1");
    }
    
    
    //------------------------------------------web functions -------------------------------------//
    
    public static String WebpageToString(String URL) 
    {
        WebRequest req = WebRequest.Create(URL);
        WebResponse res = req.GetResponse();
        int iTotalBuff = 0;
        Byte[] Buffer = new Byte[128];
        Stream stream = res.GetResponseStream();
        iTotalBuff = stream.Read(Buffer, 0, 128);
        StringBuilder strRes = new StringBuilder("");
        while (iTotalBuff != 0) 
        {
            strRes.Append(Encoding.ASCII.GetString(Buffer, 0, iTotalBuff));
            iTotalBuff = stream.Read(Buffer, 0, 128);
        }
	  return strRes.ToString();
    }
    
    
    //------------------------------------------time functions -------------------------------------//
    
    public static string Time() 
    {
    	return "The current time is: " + System.DateTime.Now.ToShortTimeString() + ".";
    }
    
    
    //------------------------------------------regex matching functions -------------------------------------//
    
    	private static GroupCollection RegexMatchGroup = null;
    
    	public static bool RegexMatch( string re_string, string text)
        {
            Regex regex = new Regex(re_string, RegexOptions.IgnoreCase);
            if (regex.IsMatch(text))
            {
                  RegexMatchGroup = regex.Match(text).Groups;
    
                  return true;
            } else {
                  RegexMatchGroup = null;
                  return false;
            }
        }
    
        public static string RegexMatchedGroup( string name) 
        {
            if (RegexMatchGroup != null)
            {
                  return RegexMatchGroup[name].Captures[0].Value;
            } else {
                  return String.Empty;
            }
        }
    
        public static string RegexMatchedGroup( int num)
        {
            if (RegexMatchGroup != null)
            {
                 return RegexMatchGroup[num].Captures[0].Value;
            } else {
                 return String.Empty;
            }
    }
}